package com.kdanmobile.reader.screen.adapter

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.BaseAdapter
import android.widget.TextView
import com.kdanmobile.kmpdfkit.pdfcommon.OutlineItem
import com.kdanmobile.reader.R

class OutlineAdapter(private val outlineListItemList: List<OutlineItem>?): BaseAdapter() {

    override fun getCount(): Int {
        return outlineListItemList?.size ?: 0
    }

    override fun getItem(position: Int): OutlineItem? {
        val isNull = null == outlineListItemList || outlineListItemList.size < position
        return if (isNull) null else outlineListItemList?.get(position)
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    override fun getView(position: Int, view: View?, parent: ViewGroup): View {
        var view = view
        val holderView: HolderView
        if (view == null) {
            view = LayoutInflater.from(parent.context).inflate(R.layout.outline_entry, null)
            holderView = HolderView(view!!)
            view!!.tag = holderView
        } else {
            holderView = view.tag as HolderView
        }

        val item = getItem(position)
        /****** 大纲层次缩进  */
        var space = ""
        val null_str = parent.context.getString(R.string.null_str)
        for (i in 1 .. item!!.level) {
            space += null_str + null_str
        }

        holderView.tv_name.text = space + item.title
        holderView.tv_name.textSize = (15 - item.level * 1.2f)
        holderView.tv_page.text = (item.page + 1).toString()
        return view
    }

    private class HolderView(view: View) {
        var tv_name: TextView
        var tv_page: TextView

        init {
            tv_name = view.findViewById<View>(R.id.tv_outlineEntry_title) as TextView
            tv_page = view.findViewById<View>(R.id.tv_outlineEntry_page) as TextView
        }
    }
}
